#define _WIN32_WINNT 0x0500
#include <windows.h>
#include <windowsx.h>
#include "dlgsize.h"
#define elemof(x) (sizeof(x)/sizeof(*(x)))

HINSTANCE ghInstance;

static void PaintButton(DRAWITEMSTRUCT*dis, COLORREF tc, COLORREF bc) {
 DWORD f;
 TCHAR text[32];
 COLORREF otc,otb;
 if (dis->itemState&ODS_FOCUS) {
  HPEN pen=CreatePen(0,0,GetSysColor(COLOR_WINDOWFRAME)),
	open=SelectPen(dis->hDC,pen);
  Rectangle(dis->hDC,
	dis->rcItem.left,
	dis->rcItem.top,
	dis->rcItem.right,
	dis->rcItem.bottom);
  InflateRect(&dis->rcItem,-1,-1);
  SelectPen(dis->hDC,open);
  DeletePen(pen);
 }
 otb=SetBkColor(dis->hDC,bc);
 ExtTextOut(dis->hDC,0,0,ETO_OPAQUE,&dis->rcItem,0,0,0);	// Rechteck mit Hintergrundfarbe fllen
 f = dis->itemState&ODS_SELECTED?EDGE_SUNKEN:EDGE_RAISED;
 DrawEdge(dis->hDC,&dis->rcItem,f,BF_RECT);	// DrawFrameControl fllt den Hintergrund, geht also nicht
 GetWindowText(dis->hwndItem,text,elemof(text));
 otc=SetTextColor(dis->hDC,tc);
 f=DT_CENTER|DT_SINGLELINE|DT_VCENTER;
 if (dis->itemState&ODS_NOACCEL) f|=DT_HIDEPREFIX;
 DrawText(dis->hDC,text,-1,&dis->rcItem,f);
 SetTextColor(dis->hDC,otc);
 SetBkColor(dis->hDC,otb);
 if (dis->itemState&ODS_FOCUS) {
  InflateRect(&dis->rcItem,-3,-3);
  DrawFocusRect(dis->hDC,&dis->rcItem);
 }
}

INT_PTR CALLBACK MainDlgProc(HWND hWnd,UINT Msg,WPARAM wParam,LPARAM lParam) {
 switch (Msg){
  case WM_INITDIALOG: { // Dialog mit Icon versehen
   HICON ico=LoadIcon(ghInstance,MAKEINTRESOURCE(1));
   SendMessage(hWnd,WM_SETICON,ICON_BIG,(LPARAM)ico);
   SendMessage(hWnd,WM_SETICON,ICON_SMALL,(LPARAM)ico);
  }return TRUE;
  
  case WM_DRAWITEM: {
   DRAWITEMSTRUCT*dis=(DRAWITEMSTRUCT*)lParam;
   switch (LOBYTE(wParam)) {
    case 20: PaintButton(dis,RGB(255,255,255),RGB(255,200,100)); break;
   }break;
  }break;

  case WM_COMMAND: switch(LOBYTE(wParam)){
   case IDOK: break;	// Ein Hauptfenster sollte bei ENTER nicht einfach verschwinden!
   case IDCANCEL: EndDialog(hWnd,(UINT)wParam); break;
   case 20: MessageBox(hWnd, "Danke!", "Farben", MB_OK|MB_ICONINFORMATION); break;
   case 21: SendMessage(hWnd,WM_SETFONT,0,SFF_SMALLER|SFF_FIXONSIZE_MOUSE); break;
   case 22: SendMessage(hWnd,WM_SETFONT,0,SFF_LARGER |SFF_FIXONSIZE_MOUSE); break;
   case 23: SendMessage(hWnd,WM_SETFONT,0,(SFF_TOGGLE<<SFF_BOLD_BIT)	|SFF_FIXONSIZE_MOUSE); break;
   case 24: SendMessage(hWnd,WM_SETFONT,0,(SFF_TOGGLE<<SFF_ITALIC_BIT)	|SFF_FIXONSIZE_MOUSE); break;
   case 25: SendMessage(hWnd,WM_SETFONT,0,(SFF_TOGGLE<<SFF_SERIF_BIT)	|SFF_FIXONSIZE_MOUSE); break;
   case 26: SendMessage(hWnd,WM_SETFONT,0,(SFF_TOGGLE<<SFF_MONO_BIT)	|SFF_FIXONSIZE_MOUSE); break;
  }break;
 }
 return 0;
}


/******************************
 * main program (entry point) *
 ******************************/
__declspec(noreturn) void WinMainCRTStartup(void) { 
 ghInstance=GetModuleHandle(0);
 InitDLL();
 ExitProcess((UINT)DialogBox(0,MAKEINTRESOURCE(1),0,MainDlgProc));
}
